<?php 
  /** 
  * Topic:       Create and parse XML files using PHP DOM-XML 
  * Source:      http://www.php.net/domxml 
  * Reference:   http://www.zugeschaut-und-mitgebaut.de/php/extension.domxml.html 
  * Author:      urs@circle.ch, 16-1-2001 
  * 
  */ 

  // create the xml processing instruction 
  $doc = new_xmldoc("1.0" ); 

  // setting the DOCTYPE is not yet implemented, but 
  // it will hopefully follow soon ;) 
  //$doc->setdtd("<!DOCTYPE faq SYSTEM \"test_dom.dtd\">"); 

  // create a root node and set an attribute 
  $root = $doc->add_root("faq" ); 
  $root->setattr("page", "32" ); 

  // create a child node 
  $one = $root->new_child("question", ""); 
  // set an attribute to the child node 
  $one->setattr("number", "1"); 
  // create a child node and add content 
  $one->new_child("text", "1. Where to get libxml-2.0.0?"); 
  $one->new_child("answer", "You can download the latest 
  release of libxml   either as a source archive or 
  RPM package from http://www.xmlsoft.org. 
  The current version is libxml2-2.2.1." ); 

  $two = $root->new_child("question", "" ); 
  $two->setattr("number", "2"); 
  $two->new_child("text", "2. How to configure PHP4?" ); 
  // create a child node without directly adding content 
  $twoone = $two->new_child("answer", ""); 
  // add the content for this node here 
  $twoone->set_content("DIR is the libxml install directory 
  (if you just use --with-dom it defaults 
  to /usr), I needed to use --with-dom=/usr/local" ); 

  $three = $root->new_child("question", "" ); 
  $three->setattr("number", "7" ); 
  $three->new_child("text", "7. How to use DOM XML function ?" ); 
  $three->new_child("answer", "Read this document source for 
  a simple example." ); 

  // print to browser 
  print("<pre>".htmlspecialchars($doc->dumpmem() )."</pre>" ); 

  // write to file 
  $fp = fopen("test_dom.xml", "w+" ); 
  fwrite($fp, $doc->dumpmem(), strlen($doc->dumpmem() )); 
  fclose($fp); 

  // ------------------------------------------------------ 
  // now get the contents back from the xml documents nodes 
  // by using xpath, which should work with PHP 4.0.4 
  $doc = xmldoc(join("", file("test_dom.xml")) ); 
  $ctx = xpath_new_context($doc ); 

  // show all objects 
  $foo = xpath_eval($ctx, "//child::*"); 
  print_r($foo); 
  print("<br/><br/>"); 
  // show object of text node 
  $foo = xpath_eval($ctx, "//text"); 
  print_r($foo); 
  print("<br/><br/>"); 
  // show object of first text node 
  $foo = xpath_eval($ctx, "//text[1]"); 
  print_r($foo); 
  print("<br/><br/>"); 
  // show object of second text node 
  $foo = xpath_eval($ctx, "//text[2]"); 
  print_r($foo); 
  print("<br/><br/>"); 
  // show object of third answer node 
  $foo = xpath_eval($ctx, "//answer[3]"); 
  print_r($foo); 
  print("<br/><br/>"); 

  // ------------------------------------------------------ 
  // get type, name and content of third text node 
  $foo = xpath_eval($ctx, "//text[3]"); 
  $tmp = $foo->nodeset; 
  print_r($tmp); 
  print("<br/>"); 
  print($tmp[0]->type) . "; "; 
  print($tmp[0]->name) . "; "; 
  print($tmp[0]->content); 

?>